package tu.kielce.pl.sqlinjectiondemo;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.SQLException;

public class PreparedQueryExecutor implements QueryExecutor {

    private final Connection connection;
    private final QueryProvider queryProvider;

    public PreparedQueryExecutor(Connection connection, QueryProvider provider) {
        this.connection = connection;
        queryProvider = provider;
    }

    @Override
    public void executeInsertQuery() {
        String insertStatement = queryProvider.getInsertQuery();
        try(PreparedStatement statement = connection.prepareStatement(insertStatement)) {
            if(queryProvider instanceof PreparedQueryProvider) {
                statement.setString(1,((PreparedQueryProvider)queryProvider).getLogin());
                statement.setString(2,((PreparedQueryProvider)queryProvider).getHashedPassword());
                statement.execute();
            }
        } catch(SQLException e) {
           e.printStackTrace();
        }
    }

    @Override
    public boolean executeSelectQuery() {
        boolean result = false;
        String selectQuery = queryProvider.getSelectQuery();
        try(PreparedStatement statement = connection.prepareStatement(selectQuery)) {
            if(queryProvider instanceof PreparedQueryProvider) {
                statement.setString(1, ((PreparedQueryProvider)queryProvider).getLogin());
                statement.setString(2,((PreparedQueryProvider)queryProvider).getHashedPassword());
                result = statement.executeQuery().next();
            }
        } catch(SQLException e) {
            e.printStackTrace();
        }
        return result;
    }
}
