package tu.kielce.pl.sqlinjectiondemo;

import javafx.application.Application;
import javafx.geometry.Insets;
import javafx.scene.Scene;
import javafx.scene.layout.VBox;
import javafx.stage.Stage;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;


public class SQLInjectionDemo extends Application {
    private static Connection connection;

    @Override
    public void start(Stage stage) {
        try {
            connection = DriverManager.getConnection("jdbc:h2:./test;INIT=RUNSCRIPT FROM 'classpath:users.sql';");
            AuthenticationPanel authenticationPanel = new AuthenticationPanel();
            VBox mainPanel = new VBox();
            mainPanel.setSpacing(10);
            mainPanel.setPadding(new Insets(10));
            mainPanel.getChildren().add(authenticationPanel);
            QueryProvider provider = new SimpleQueryProvider();
            QueryExecutor executor = new SimpleQueryExecutor(connection, provider);
            SignUpManager signUpManager = new SignUpManager(authenticationPanel,provider,executor);
            signUpManager.setup();
            LoginManager loginManager = new LoginManager(authenticationPanel, provider, executor);
            loginManager.setup();
            mainPanel.getChildren().add(signUpManager.getSignUPButton());
            mainPanel.getChildren().add(loginManager.getLoginButton());
            Scene scene = new Scene(mainPanel, 300, 140);
            stage.setTitle("SQL Injection Demo");
            stage.setScene(scene);
            stage.show();
        } catch (SQLException e) {
            e.printStackTrace();
        }
    }
    public static void main(String[] args) {
        launch();
        try {
            connection.close();
        } catch (SQLException e) {
            e.printStackTrace();
        }
    }
}