package tu.kielce.pl.sqlinjectiondemo;

import javafx.scene.control.Button;
import org.springframework.security.crypto.argon2.Argon2PasswordEncoder;

public class SignUpManager {
    private final AuthenticationPanel authenticationPanel;
    private final Button signUPButton = new Button("Sign Up");
    private final QueryExecutor queryExecutor;
    private final QueryProvider queryProvider;

    public SignUpManager(AuthenticationPanel panel, QueryProvider queryProvider, QueryExecutor queryExecutor) {
        authenticationPanel = panel;
        this.queryExecutor = queryExecutor;
        this.queryProvider = queryProvider;
        signUPButton.setPrefSize(290,20);
    }
   public void setup() {
        signUPButton.setOnAction(actionEvent -> {
            String login = authenticationPanel.getLogin();
            String hashedPassword = hashPassword(authenticationPanel.getPassword());
            queryProvider.setLogin(login);
            queryProvider.setHashedPassword(hashedPassword);
            queryExecutor.executeInsertQuery();
        });
    }

    private String hashPassword(String password) {
        Argon2PasswordEncoder encoder = new Argon2PasswordEncoder(0,64,1,15*1024,1);
        return encoder.encode(password);
    }

    public Button getSignUPButton() {
        return signUPButton;
    }
}
