package tu.kielce.pl.sqlinjectiondemo;

import java.sql.*;

public class SimpleQueryExecutor implements QueryExecutor {

    private final Connection connection;
    private final QueryProvider queryProvider;

    public SimpleQueryExecutor(Connection connection, QueryProvider provider) {
        queryProvider = provider;
        this.connection = connection;
    }

    @Override
    public void executeInsertQuery() {
        try(Statement statement = connection.createStatement()) {
            statement.execute(queryProvider.getInsertQuery());
        } catch(SQLException e) {
            e.printStackTrace();
        }
    }

    @Override
    public boolean executeSelectQuery() {
        boolean result = false;
        try(Statement statement = connection.createStatement()) {
            result = statement.executeQuery(queryProvider.getSelectQuery()).next();
        } catch(SQLException e) {
            e.printStackTrace();
        }
        return result;
    }
}
